temporarily disable elisp exception tests
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
5e69ceb7 5## Copyright (C) 2001-2014 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
7f1ea859
LC
24# Diagnostic for continued use of deprecated variable.
25# Remove in 2013
26ifneq ($(build_aux),)
27 $(error "$(ME): \
28set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29endif
c84bdaf6 30
7ae4e75a
LC
31# Helper variables.
32_empty =
33_sp = $(_empty) $(_empty)
34
35# _equal,S1,S2
36# ------------
37# If S1 == S2, return S1, otherwise the empty string.
38_equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
39
40# member-check,VARIABLE,VALID-VALUES
41# ----------------------------------
42# Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
43# return it. Die otherwise.
44member-check = \
45 $(strip \
46 $(if $($(1)), \
47 $(if $(findstring $(_sp),$($(1))), \
48 $(error invalid $(1): '$($(1))', expected $(2)), \
49 $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
50 $(error invalid $(1): '$($(1))', expected $(2)))), \
51 $(error $(1) undefined)))
52
c84bdaf6
LC
53# Do not save the original name or timestamp in the .tar.gz file.
54# Use --rsyncable if available.
55gzip_rsyncable := \
a927b6c1
LC
56 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
57 && printf %s --rsyncable)
c84bdaf6
LC
58GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
59
c84bdaf6
LC
60GIT = git
61VC = $(GIT)
c84bdaf6 62
7f1ea859 63VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
c84bdaf6 64
61cd9dc9
LC
65# You can override this variable in cfg.mk to set your own regexp
66# matching files to ignore.
67VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
68
69# This is to preprocess robustly the output of $(VC_LIST), so that even
70# when $(srcdir) is a pathological name like "....", the leading sed command
71# removes only the intended prefix.
72_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
73
74# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
75# when $(srcdir) is not ".".
76ifeq ($(srcdir),.)
7ae4e75a 77 _prepend_srcdir_prefix =
61cd9dc9 78else
8f7887d6 79 _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
61cd9dc9
LC
80endif
81
82# In order to be able to consistently filter "."-relative names,
83# (i.e., with no $(srcdir) prefix), this definition is careful to
84# remove any $(srcdir) prefix, and to restore what it removes.
dd7d0148 85_sc_excl = \
7ae4e75a 86 $(or $(exclude_file_name_regexp--$@),^$$)
c84bdaf6 87VC_LIST_EXCEPT = \
8f7887d6 88 $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
61cd9dc9
LC
89 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
90 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
dd7d0148 91 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
61cd9dc9 92 $(_prepend_srcdir_prefix)
c84bdaf6
LC
93
94ifeq ($(origin prev_version_file), undefined)
95 prev_version_file = $(srcdir)/.prev-version
96endif
97
98PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
99VERSION_REGEXP = $(subst .,\.,$(VERSION))
100PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
101
102ifeq ($(VC),$(GIT))
7ae4e75a
LC
103 this-vc-tag = v$(VERSION)
104 this-vc-tag-regexp = v$(VERSION_REGEXP)
c84bdaf6 105else
7ae4e75a
LC
106 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
107 tag-this-version = $(subst .,_,$(VERSION))
108 this-vc-tag = $(tag-package)-$(tag-this-version)
109 this-vc-tag-regexp = $(this-vc-tag)
c84bdaf6
LC
110endif
111my_distdir = $(PACKAGE)-$(VERSION)
112
113# Old releases are stored here.
114release_archive_dir ?= ../release
115
7ae4e75a
LC
116# If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
117# But overwrite VERSION.
118ifdef RELEASE
119 VERSION := $(word 1, $(RELEASE))
120 RELEASE_TYPE ?= $(word 2, $(RELEASE))
121endif
122
123# Validate and return $(RELEASE_TYPE), or die.
124RELEASE_TYPES = alpha beta stable
125release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
126
414e4441
LC
127# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
128# Use alpha.gnu.org for alpha and beta releases.
129# Use ftp.gnu.org for stable releases.
130gnu_ftp_host-alpha = alpha.gnu.org
131gnu_ftp_host-beta = alpha.gnu.org
132gnu_ftp_host-stable = ftp.gnu.org
7ae4e75a 133gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
414e4441 134
7ae4e75a
LC
135url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
136 http://ftpmirror.gnu.org/$(PACKAGE), \
137 ftp://$(gnu_rel_host)/gnu/$(PACKAGE))
414e4441 138
1cd4fffc
LC
139# Override this in cfg.mk if you are using a different format in your
140# NEWS file.
141today = $(shell date +%Y-%m-%d)
9157d901
LC
142
143# Select which lines of NEWS are searched for $(news-check-regexp).
144# This is a sed line number spec. The default says that we search
145# lines 1..10 of NEWS for $(news-check-regexp).
146# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
147news-check-lines-spec ?= 1,10
1cd4fffc
LC
148news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
149
c84bdaf6
LC
150# Prevent programs like 'sort' from considering distinct strings to be equal.
151# Doing it here saves us from having to set LC_ALL elsewhere in this file.
152export LC_ALL = C
153
154## --------------- ##
155## Sanity checks. ##
156## --------------- ##
157
af07e104 158_cfg_mk := $(wildcard $(srcdir)/cfg.mk)
c84bdaf6 159
f0007cad 160# Collect the names of rules starting with 'sc_'.
8f7887d6
LC
161syntax-check-rules := $(sort $(shell $(SED) -n \
162 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
c84bdaf6
LC
163.PHONY: $(syntax-check-rules)
164
dd36ce77 165ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
7ae4e75a 166 local-checks-available += $(syntax-check-rules)
dd36ce77 167else
7ae4e75a 168 local-checks-available += no-vc-detected
dd36ce77
MW
169no-vc-detected:
170 @echo "No version control files detected; skipping syntax check"
171endif
c84bdaf6
LC
172.PHONY: $(local-checks-available)
173
174# Arrange to print the name of each syntax-checking rule just before running it.
175$(syntax-check-rules): %: %.m
dde9c5a4
LC
176sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
177.PHONY: $(sc_m_rules_)
178$(sc_m_rules_):
c84bdaf6 179 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
180 @date +%s.%N > .sc-start-$(basename $@)
181
182# Compute and print the elapsed time for each syntax-check rule.
183sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
184.PHONY: $(sc_z_rules_)
185$(sc_z_rules_): %.z: %
186 @end=$$(date +%s.%N); \
187 start=$$(cat .sc-start-$*); \
188 rm -f .sc-start-$*; \
189 awk -v s=$$start -v e=$$end \
190 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
191
192# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
193# that computes and prints elapsed time.
194local-check := \
195 $(patsubst sc_%, sc_%.z, \
196 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
197
198syntax-check: $(local-check)
a927b6c1
LC
199
200# _sc_search_regexp
201#
202# This macro searches for a given construct in the selected files and
203# then takes some action.
204#
205# Parameters (shell variables):
206#
207# prohibit | require
208#
209# Regular expression (ERE) denoting either a forbidden construct
210# or a required construct. Those arguments are exclusive.
211#
005de2e8
LC
212# exclude
213#
214# Regular expression (ERE) denoting lines to ignore that matched
215# a prohibit construct. For example, this can be used to exclude
216# comments that mention why the nearby code uses an alternative
217# construct instead of the simpler prohibited construct.
218#
a927b6c1
LC
219# in_vc_files | in_files
220#
7ae4e75a
LC
221# grep-E-style regexp selecting the files to check. For in_vc_files,
222# the regexp is used to select matching files from the list of all
223# version-controlled files; for in_files, it's from the names printed
224# by "find $(srcdir)". When neither is specified, use all files that
225# are under version control.
a927b6c1
LC
226#
227# containing | non_containing
228#
229# Select the files (non) containing strings matching this regexp.
230# If both arguments are specified then CONTAINING takes
231# precedence.
232#
233# with_grep_options
234#
235# Extra options for grep.
236#
237# ignore_case
238#
239# Ignore case.
240#
241# halt
242#
243# Message to display before to halting execution.
dd7d0148
LC
244#
245# Finally, you may exempt files based on an ERE matching file names.
246# For example, to exempt from the sc_space_tab check all files with the
247# .diff suffix, set this Make variable:
248#
249# exclude_file_name_regexp--sc_space_tab = \.diff$
250#
251# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
252# when filtering by name via in_files, we explicitly filter out matching
253# names here as well.
a927b6c1 254
005de2e8
LC
255# Initialize each, so that envvar settings cannot interfere.
256export require =
257export prohibit =
258export exclude =
259export in_vc_files =
260export in_files =
261export containing =
262export non_containing =
263export halt =
264export with_grep_options =
265
a927b6c1 266# By default, _sc_search_regexp does not ignore case.
c84bdaf6 267export ignore_case =
a927b6c1 268_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 269
a927b6c1
LC
270define _sc_say_and_exit
271 dummy=; : so we do not need a semicolon before each use; \
272 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
273endef
274
a927b6c1
LC
275define _sc_search_regexp
276 dummy=; : so we do not need a semicolon before each use; \
277 \
278 : Check arguments; \
279 test -n "$$prohibit" && test -n "$$require" \
280 && { msg='Cannot specify both prohibit and require' \
281 $(_sc_say_and_exit) } || :; \
282 test -z "$$prohibit" && test -z "$$require" \
283 && { msg='Should specify either prohibit or require' \
284 $(_sc_say_and_exit) } || :; \
005de2e8
LC
285 test -z "$$prohibit" && test -n "$$exclude" \
286 && { msg='Use of exclude requires a prohibit pattern' \
287 $(_sc_say_and_exit) } || :; \
a927b6c1
LC
288 test -n "$$in_vc_files" && test -n "$$in_files" \
289 && { msg='Cannot specify both in_vc_files and in_files' \
290 $(_sc_say_and_exit) } || :; \
291 test "x$$halt" != x \
292 || { msg='halt not defined' $(_sc_say_and_exit) }; \
293 \
294 : Filter by file name; \
295 if test -n "$$in_files"; then \
dd7d0148 296 files=$$(find $(srcdir) | grep -E "$$in_files" \
7ae4e75a 297 | grep -Ev '$(_sc_excl)'); \
a927b6c1
LC
298 else \
299 files=$$($(VC_LIST_EXCEPT)); \
300 if test -n "$$in_vc_files"; then \
301 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
302 fi; \
303 fi; \
304 \
305 : Filter by content; \
306 test -n "$$files" && test -n "$$containing" \
307 && { files=$$(grep -l "$$containing" $$files); } || :; \
308 test -n "$$files" && test -n "$$non_containing" \
309 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
310 \
311 : Check for the construct; \
312 if test -n "$$files"; then \
313 if test -n "$$prohibit"; then \
314 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
005de2e8 315 | grep -vE "$${exclude:-^$$}" \
a927b6c1
LC
316 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
317 else \
318 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
319 | grep . \
320 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
321 fi \
322 else :; \
323 fi || :;
c84bdaf6
LC
324endef
325
326sc_avoid_if_before_free:
7f1ea859 327 @$(srcdir)/$(_build-aux)/useless-if-before-free \
c84bdaf6
LC
328 $(useless_free_options) \
329 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
330 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
331 exit 1; } || :
332
333sc_cast_of_argument_to_free:
005de2e8 334 @prohibit='\<free *\( *\(' halt="don't cast free argument" \
a927b6c1 335 $(_sc_search_regexp)
c84bdaf6
LC
336
337sc_cast_of_x_alloc_return_value:
a927b6c1 338 @prohibit='\*\) *x(m|c|re)alloc\>' \
005de2e8 339 halt="don't cast x*alloc return value" \
a927b6c1 340 $(_sc_search_regexp)
c84bdaf6
LC
341
342sc_cast_of_alloca_return_value:
a927b6c1 343 @prohibit='\*\) *alloca\>' \
005de2e8 344 halt="don't cast alloca return value" \
a927b6c1 345 $(_sc_search_regexp)
c84bdaf6
LC
346
347sc_space_tab:
a927b6c1
LC
348 @prohibit='[ ] ' \
349 halt='found SPACE-TAB sequence; remove the SPACE' \
350 $(_sc_search_regexp)
c84bdaf6 351
f0007cad 352# Don't use *scanf or the old ato* functions in "real" code.
c84bdaf6
LC
353# They provide no error checking mechanism.
354# Instead, use strto* functions.
355sc_prohibit_atoi_atof:
a927b6c1
LC
356 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
357 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
358 $(_sc_search_regexp)
c84bdaf6
LC
359
360# Use STREQ rather than comparing strcmp == 0, or != 0.
005de2e8 361sp_ = strcmp *\(.+\)
c84bdaf6 362sc_prohibit_strcmp:
005de2e8 363 @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
7ae4e75a
LC
364 exclude='# *define STRN?EQ\(' \
365 halt='replace strcmp calls above with STREQ/STRNEQ' \
005de2e8
LC
366 $(_sc_search_regexp)
367
368# Really. You don't want to use this function.
369# It may fail to NUL-terminate the destination,
370# and always NUL-pads out to the specified length.
371sc_prohibit_strncpy:
372 @prohibit='\<strncpy *\(' \
373 halt='do not use strncpy, period' \
374 $(_sc_search_regexp)
c84bdaf6
LC
375
376# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
377# Convert all uses automatically, via these two commands:
378# git grep -l '\<exit *(1)' \
379# | grep -vEf .x-sc_prohibit_magic_number_exit \
380# | xargs --no-run-if-empty \
381# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
382# git grep -l '\<exit *(0)' \
383# | grep -vEf .x-sc_prohibit_magic_number_exit \
384# | xargs --no-run-if-empty \
385# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 386sc_prohibit_magic_number_exit:
7ae4e75a
LC
387 @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
388 exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
389 halt='use EXIT_* values rather than magic number' \
a927b6c1 390 $(_sc_search_regexp)
c84bdaf6
LC
391
392# Using EXIT_SUCCESS as the first argument to error is misleading,
f0007cad 393# since when that parameter is 0, error does not exit. Use '0' instead.
c84bdaf6 394sc_error_exit_success:
a927b6c1
LC
395 @prohibit='error *\(EXIT_SUCCESS,' \
396 in_vc_files='\.[chly]$$' \
397 halt='found error (EXIT_SUCCESS' \
398 $(_sc_search_regexp)
c84bdaf6 399
f0007cad
LC
400# "FATAL:" should be fully upper-cased in error messages
401# "WARNING:" should be fully upper-cased, or fully lower-cased
c84bdaf6 402sc_error_message_warn_fatal:
a927b6c1 403 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
404 | grep -E '"Warning|"Fatal|"fatal' && \
405 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
406 exit 1; } || :
407
408# Error messages should not start with a capital letter
409sc_error_message_uppercase:
a927b6c1 410 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
411 | grep -E '"[A-Z]' \
412 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
413 { echo '$(ME): found capitalized error message' 1>&2; \
414 exit 1; } || :
415
416# Error messages should not end with a period
417sc_error_message_period:
a927b6c1 418 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
419 | grep -E '[^."]\."' && \
420 { echo '$(ME): found error message ending in period' 1>&2; \
421 exit 1; } || :
422
423sc_file_system:
a927b6c1
LC
424 @prohibit=file''system \
425 ignore_case=1 \
426 halt='found use of "file''system"; spell it "file system"' \
427 $(_sc_search_regexp)
c84bdaf6
LC
428
429# Don't use cpp tests of this symbol. All code assumes config.h is included.
430sc_prohibit_have_config_h:
a927b6c1
LC
431 @prohibit='^# *if.*HAVE''_CONFIG_H' \
432 halt='found use of HAVE''_CONFIG_H; remove' \
433 $(_sc_search_regexp)
c84bdaf6
LC
434
435# Nearly all .c files must include <config.h>. However, we also permit this
436# via inclusion of a package-specific header, if cfg.mk specified one.
437# config_h_header must be suitable for grep -E.
438config_h_header ?= <config\.h>
439sc_require_config_h:
a927b6c1
LC
440 @require='^# *include $(config_h_header)' \
441 in_vc_files='\.c$$' \
442 halt='the above files do not include <config.h>' \
443 $(_sc_search_regexp)
c84bdaf6
LC
444
445# You must include <config.h> before including any other header file.
446# This can possibly be via a package-specific header, if given by cfg.mk.
447sc_require_config_h_first:
448 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
449 fail=0; \
450 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
8f7887d6 451 grep '^# *include\>' $$i | $(SED) 1q \
c84bdaf6
LC
452 | grep -E '^# *include $(config_h_header)' > /dev/null \
453 || { echo $$i; fail=1; }; \
454 done; \
455 test $$fail = 1 && \
456 { echo '$(ME): the above files include some other header' \
457 'before <config.h>' 1>&2; exit 1; } || :; \
458 else :; \
459 fi
460
461sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
462 @prohibit='\bHAVE_MBRTOWC\b' \
463 halt="do not use $$prohibit; it is always defined" \
464 $(_sc_search_regexp)
c84bdaf6
LC
465
466# To use this "command" macro, you must first define two shell variables:
231c0e0e 467# h: the header name, with no enclosing <> or ""
c84bdaf6 468# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 469define _sc_header_without_use
c84bdaf6 470 dummy=; : so we do not need a semicolon before each use; \
8f7887d6 471 h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
c84bdaf6
LC
472 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
473 files=$$(grep -l '^# *include '"$$h_esc" \
474 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
475 grep -LE "$$re" $$files | grep . && \
476 { echo "$(ME): the above files include $$h but don't use it" \
477 1>&2; exit 1; } || :; \
478 else :; \
479 fi
480endef
481
482# Prohibit the inclusion of assert.h without an actual use of assert.
483sc_prohibit_assert_without_use:
231c0e0e 484 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
485
486# Prohibit the inclusion of close-stream.h without an actual use.
487sc_prohibit_close_stream_without_use:
231c0e0e 488 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
489
490# Prohibit the inclusion of getopt.h without an actual use.
491sc_prohibit_getopt_without_use:
231c0e0e 492 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
493
494# Don't include quotearg.h unless you use one of its functions.
495sc_prohibit_quotearg_without_use:
231c0e0e 496 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
497
498# Don't include quote.h unless you use one of its functions.
499sc_prohibit_quote_without_use:
005de2e8
LC
500 @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
501 $(_sc_header_without_use)
c84bdaf6
LC
502
503# Don't include this header unless you use one of its functions.
504sc_prohibit_long_options_without_use:
231c0e0e 505 @h='long-options.h' re='\<parse_long_options *\(' \
a927b6c1 506 $(_sc_header_without_use)
c84bdaf6
LC
507
508# Don't include this header unless you use one of its functions.
509sc_prohibit_inttostr_without_use:
231c0e0e 510 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 511 $(_sc_header_without_use)
c84bdaf6 512
61cd9dc9
LC
513# Don't include this header unless you use one of its functions.
514sc_prohibit_ignore_value_without_use:
231c0e0e 515 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
a927b6c1 516 $(_sc_header_without_use)
61cd9dc9 517
c84bdaf6
LC
518# Don't include this header unless you use one of its functions.
519sc_prohibit_error_without_use:
231c0e0e 520 @h='error.h' \
c84bdaf6 521 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 522 $(_sc_header_without_use)
c84bdaf6
LC
523
524# Don't include xalloc.h unless you use one of its functions.
525# Consider these symbols:
526# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 527# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
528# Divide into two sets on case, and filter each through this:
529# | sort | perl -MRegexp::Assemble -le \
530# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
531# Note this was produced by the above:
61cd9dc9
LC
532# _xa1 = \
533#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
534# But we can do better, in at least two ways:
535# 1) take advantage of two "dup"-suffixed strings:
536# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
537# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
538# "char|[cmz]"
539# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
540_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
541_xa2 = X([CZ]|N?M)ALLOC
542sc_prohibit_xalloc_without_use:
231c0e0e 543 @h='xalloc.h' \
c84bdaf6 544 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 545 $(_sc_header_without_use)
c84bdaf6 546
dde9c5a4 547# Extract function names:
a927b6c1 548# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
549_hash_re = \
550clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
551_hash_fn = \<($(_hash_re)) *\(
552_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
553sc_prohibit_hash_without_use:
231c0e0e 554 @h='hash.h' \
dde9c5a4 555 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 556 $(_sc_header_without_use)
dde9c5a4 557
3d458a81 558sc_prohibit_cloexec_without_use:
231c0e0e 559 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
3d458a81
AW
560 $(_sc_header_without_use)
561
562sc_prohibit_posixver_without_use:
231c0e0e 563 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
3d458a81
AW
564
565sc_prohibit_same_without_use:
231c0e0e 566 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
3d458a81 567
dde9c5a4 568sc_prohibit_hash_pjw_without_use:
231c0e0e 569 @h='hash-pjw.h' \
005de2e8 570 re='\<hash_pjw\>' \
a927b6c1 571 $(_sc_header_without_use)
dde9c5a4 572
c84bdaf6 573sc_prohibit_safe_read_without_use:
231c0e0e 574 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 575 $(_sc_header_without_use)
c84bdaf6
LC
576
577sc_prohibit_argmatch_without_use:
231c0e0e 578 @h='argmatch.h' \
35428fb6 579 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
a927b6c1 580 $(_sc_header_without_use)
c84bdaf6
LC
581
582sc_prohibit_canonicalize_without_use:
231c0e0e 583 @h='canonicalize.h' \
005de2e8 584 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
a927b6c1 585 $(_sc_header_without_use)
c84bdaf6
LC
586
587sc_prohibit_root_dev_ino_without_use:
231c0e0e 588 @h='root-dev-ino.h' \
c84bdaf6 589 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 590 $(_sc_header_without_use)
c84bdaf6
LC
591
592sc_prohibit_openat_without_use:
231c0e0e 593 @h='openat.h' \
5e69ceb7 594 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
a927b6c1 595 $(_sc_header_without_use)
c84bdaf6
LC
596
597# Prohibit the inclusion of c-ctype.h without an actual use.
598ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
599|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
600sc_prohibit_c_ctype_without_use:
231c0e0e 601 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
a927b6c1 602 $(_sc_header_without_use)
c84bdaf6 603
c84bdaf6
LC
604# The following list was generated by running:
605# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
606# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
607_sig_functions = \
608 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
609 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
610 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
611 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
612_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
613# The following were extracted from "man signal.h" manually.
614_sig_types_and_consts = \
615 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
616 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
617 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
618 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
619 sigstack sigval stack_t ucontext_t
620# generated via this:
621# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
622_sig_names = \
623 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
624 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
625 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
626 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
627 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
628 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
629 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
630 SIGXCPU SIGXFSZ
631_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
632
633# Prohibit the inclusion of signal.h without an actual use.
634sc_prohibit_signal_without_use:
231c0e0e 635 @h='signal.h' \
c84bdaf6 636 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
637 $(_sc_header_without_use)
638
3d458a81
AW
639# Don't include stdio--.h unless you use one of its functions.
640sc_prohibit_stdio--_without_use:
231c0e0e 641 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
3d458a81
AW
642 $(_sc_header_without_use)
643
644# Don't include stdio-safer.h unless you use one of its functions.
645sc_prohibit_stdio-safer_without_use:
231c0e0e 646 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
3d458a81
AW
647 $(_sc_header_without_use)
648
a927b6c1
LC
649# Prohibit the inclusion of strings.h without a sensible use.
650# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
651sc_prohibit_strings_without_use:
231c0e0e 652 @h='strings.h' \
a927b6c1
LC
653 re='\<(strn?casecmp|ffs(ll)?)\>' \
654 $(_sc_header_without_use)
655
656# Get the list of symbol names with this:
231c0e0e 657# perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
a927b6c1
LC
658_intprops_names = \
659 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
660 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
231c0e0e
LC
661 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
662 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
663 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
664 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
665 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
666 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
667 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
a927b6c1
LC
668_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
669# Prohibit the inclusion of intprops.h without an actual use.
670sc_prohibit_intprops_without_use:
231c0e0e 671 @h='intprops.h' \
a927b6c1
LC
672 re='\<($(_intprops_syms_re)) *\(' \
673 $(_sc_header_without_use)
c84bdaf6 674
49114fd4
LC
675_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
676# Prohibit the inclusion of stddef.h without an actual use.
677sc_prohibit_stddef_without_use:
231c0e0e 678 @h='stddef.h' \
7f1ea859
LC
679 re='\<($(_stddef_syms_re))\>' \
680 $(_sc_header_without_use)
681
682_de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
683_de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
684_de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
685_dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
686# Prohibit the inclusion of dirent.h without an actual use.
687sc_prohibit_dirent_without_use:
688 @h='dirent.h' \
689 re='\<($(_dirent_syms_re))\>' \
49114fd4
LC
690 $(_sc_header_without_use)
691
35428fb6
LC
692# Prohibit the inclusion of verify.h without an actual use.
693sc_prohibit_verify_without_use:
694 @h='verify.h' \
695 re='\<(verify(true|expr)?|static_assert) *\(' \
696 $(_sc_header_without_use)
697
3d458a81
AW
698# Don't include xfreopen.h unless you use one of its functions.
699sc_prohibit_xfreopen_without_use:
231c0e0e 700 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
3d458a81 701
c84bdaf6 702sc_obsolete_symbols:
a927b6c1
LC
703 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
704 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
705 $(_sc_search_regexp)
c84bdaf6
LC
706
707# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
708
709# Each nonempty ChangeLog line must start with a year number, or a TAB.
710sc_changelog:
a927b6c1
LC
711 @prohibit='^[^12 ]' \
712 in_vc_files='^ChangeLog$$' \
713 halt='found unexpected prefix in a ChangeLog' \
714 $(_sc_search_regexp)
c84bdaf6
LC
715
716# Ensure that each .c file containing a "main" function also
717# calls set_program_name.
718sc_program_name:
a927b6c1
LC
719 @require='set_program_name *\(m?argv\[0\]\);' \
720 in_vc_files='\.c$$' \
0f00f2c3 721 containing='\<main *(' \
a927b6c1
LC
722 halt='the above files do not call set_program_name' \
723 $(_sc_search_regexp)
c84bdaf6 724
0f00f2c3
LC
725# Ensure that each .c file containing a "main" function also
726# calls bindtextdomain.
727sc_bindtextdomain:
728 @require='bindtextdomain *\(' \
729 in_vc_files='\.c$$' \
730 containing='\<main *(' \
731 halt='the above files do not call bindtextdomain' \
732 $(_sc_search_regexp)
733
c84bdaf6
LC
734# Require that the final line of each test-lib.sh-using test be this one:
735# Exit $fail
736# Note: this test requires GNU grep's --label= option.
737Exit_witness_file ?= tests/test-lib.sh
738Exit_base := $(notdir $(Exit_witness_file))
739sc_require_test_exit_idiom:
740 @if test -f $(srcdir)/$(Exit_witness_file); then \
741 die=0; \
742 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
743 $$($(VC_LIST) tests)); do \
744 tail -n1 $$i | grep '^Exit .' > /dev/null \
745 && : || { die=1; echo $$i; } \
746 done; \
747 test $$die = 1 && \
748 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
749 echo 1>&2 'Exit something'; \
750 exit 1; } || :; \
751 fi
752
c84bdaf6 753sc_trailing_blank:
a927b6c1
LC
754 @prohibit='[ ]$$' \
755 halt='found trailing blank(s)' \
7ae4e75a 756 exclude='^Binary file .* matches$$' \
a927b6c1 757 $(_sc_search_regexp)
c84bdaf6
LC
758
759# Match lines like the following, but where there is only one space
760# between the options and the description:
761# -D, --all-repeated[=delimit-method] print all duplicate lines\n
762longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
763sc_two_space_separator_in_usage:
a927b6c1
LC
764 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
765 halt='help2man requires at least two spaces between an option and its description'\
766 $(_sc_search_regexp)
c84bdaf6 767
3d458a81
AW
768# A regexp matching function names like "error" that may be used
769# to emit translatable messages.
770_gl_translatable_diag_func_re ?= error
771
c84bdaf6
LC
772# Look for diagnostics that aren't marked for translation.
773# This won't find any for which error's format string is on a separate line.
774sc_unmarked_diagnostics:
005de2e8
LC
775 @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
776 exclude='(_|ngettext ?)\(' \
7ae4e75a 777 halt='found unmarked diagnostic(s)' \
005de2e8 778 $(_sc_search_regexp)
c84bdaf6
LC
779
780# Avoid useless parentheses like those in this example:
781# #if defined (SYMBOL) || defined (SYM2)
782sc_useless_cpp_parens:
a927b6c1
LC
783 @prohibit='^# *if .*defined *\(' \
784 halt='found useless parentheses in cpp directive' \
785 $(_sc_search_regexp)
786
787# List headers for which HAVE_HEADER_H is always true, assuming you are
788# using the appropriate gnulib module. CAUTION: for each "unnecessary"
789# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
790# requires the gnulib module that guarantees the usability of that header.
791gl_assured_headers_ = \
8f7887d6 792 cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
a927b6c1
LC
793
794# Convert the list of names to upper case, and replace each space with "|".
795az_ = abcdefghijklmnopqrstuvwxyz
796AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
797gl_header_upper_case_or_ = \
798 $$($(gl_assured_headers_) \
799 | tr $(az_)/.- $(AZ_)___ \
800 | tr -s ' ' '|' \
801 )
802sc_prohibit_always_true_header_tests:
803 @or=$(gl_header_upper_case_or_); \
804 re="HAVE_($$or)_H"; \
805 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
806 halt=$$(printf '%s\n' \
807 'do not test the above HAVE_<header>_H symbol(s);' \
808 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
809 $(_sc_search_regexp)
810
7ae4e75a 811sc_prohibit_defined_have_decl_tests:
5e69ceb7 812 @prohibit='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
7ae4e75a
LC
813 halt='HAVE_DECL macros are always defined' \
814 $(_sc_search_regexp)
815
a927b6c1
LC
816# ==================================================================
817gl_other_headers_ ?= \
818 intprops.h \
819 openat.h \
820 stat-macros.h
821
822# Perl -lne code to extract "significant" cpp-defined symbols from a
823# gnulib header file, eliminating a few common false-positives.
7f1ea859
LC
824# The exempted names below are defined only conditionally in gnulib,
825# and hence sometimes must/may be defined in application code.
a927b6c1
LC
826gl_extract_significant_defines_ = \
827 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
828 && $$2 !~ /(?:rpl_|_used_without_)/\
7f1ea859 829 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
35428fb6 830 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
a927b6c1
LC
831 and print $$1
832
833# Create a list of regular expressions matching the names
834# of macros that are guaranteed to be defined by parts of gnulib.
835define def_sym_regex
836 gen_h=$(gl_generated_headers_); \
837 (cd $(gnulib_dir)/lib; \
838 for f in *.in.h $(gl_other_headers_); do \
35428fb6
LC
839 test -f $$f \
840 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
a927b6c1
LC
841 done; \
842 ) | sort -u \
8f7887d6 843 | $(SED) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
a927b6c1
LC
844endef
845
846# Don't define macros that we already get from gnulib header files.
847sc_prohibit_always-defined_macros:
848 @if test -d $(gnulib_dir); then \
849 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
850 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
851 esac; \
852 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
853 && { echo '$(ME): define the above via some gnulib .h file' \
854 1>&2; exit 1; } || :; \
855 fi
856# ==================================================================
857
858# Prohibit checked in backup files.
859sc_prohibit_backup_files:
860 @$(VC_LIST) | grep '~$$' && \
861 { echo '$(ME): found version controlled backup file' 1>&2; \
862 exit 1; } || :
c84bdaf6
LC
863
864# Require the latest GPL.
865sc_GPL_version:
a927b6c1
LC
866 @prohibit='either ''version [^3]' \
867 halt='GPL vN, N!=3' \
868 $(_sc_search_regexp)
c84bdaf6 869
61cd9dc9
LC
870# Require the latest GFDL. Two regexp, since some .texi files end up
871# line wrapping between 'Free Documentation License,' and 'Version'.
872_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
873sc_GFDL_version:
a927b6c1
LC
874 @prohibit='$(_GFDL_regexp)' \
875 halt='GFDL vN, N!=3' \
876 $(_sc_search_regexp)
877
0f00f2c3
LC
878# Don't use Texinfo's @acronym{}.
879# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
880texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
881sc_texinfo_acronym:
882 @prohibit='@acronym\{' \
883 in_vc_files='$(texinfo_suffix_re_)' \
884 halt='found use of Texinfo @acronym{}' \
885 $(_sc_search_regexp)
61cd9dc9 886
c84bdaf6
LC
887cvs_keywords = \
888 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
889
890sc_prohibit_cvs_keyword:
a927b6c1
LC
891 @prohibit='\$$($(cvs_keywords))\$$' \
892 halt='do not use CVS keyword expansion' \
893 $(_sc_search_regexp)
894
895# This Perl code is slightly obfuscated. Not only is each "$" doubled
896# because it's in a Makefile, but the $$c's are comments; we cannot
897# use "#" due to the way the script ends up concatenated onto one line.
898# It would be much more concise, and would produce better output (including
899# counts) if written as:
900# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
901# but that would be far less efficient, reading the entire contents
902# of each file, rather than just the last two bytes of each.
dd36ce77
MW
903# In addition, while the code below detects both blank lines and a missing
904# newline at EOF, the above detects only the former.
a927b6c1
LC
905#
906# This is a perl script that is expected to be the single-quoted argument
907# to a command-line "-le". The remaining arguments are file names.
f0007cad 908# Print the name of each file that does not end in exactly one newline byte.
dd36ce77
MW
909# I.e., warn if there are blank lines (2 or more newlines), or if the
910# last byte is not a newline. However, currently we don't complain
911# about any file that contains exactly one byte.
a927b6c1
LC
912# Exit nonzero if at least one such file is found, otherwise, exit 0.
913# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
914#
915# Use this if you want to remove trailing empty lines from selected files:
916# perl -pi -0777 -e 's/\n\n+$/\n/' files...
917#
dd36ce77 918require_exactly_one_NL_at_EOF_ = \
a927b6c1
LC
919 foreach my $$f (@ARGV) \
920 { \
921 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
922 my $$p = sysseek (F, -2, 2); \
923 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
924 my $$last_two_bytes; \
925 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
926 close F; \
927 $$c = "ignore read failure"; \
dd36ce77
MW
928 $$p && ($$last_two_bytes eq "\n\n" \
929 || substr ($$last_two_bytes,1) ne "\n") \
930 and (print $$f), $$fail=1; \
a927b6c1
LC
931 } \
932 END { exit defined $$fail }
933sc_prohibit_empty_lines_at_EOF:
dd36ce77 934 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
dd7d0148
LC
935 || { echo '$(ME): empty line(s) or no newline at EOF' \
936 1>&2; exit 1; } || :
c84bdaf6
LC
937
938# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
939# This is a bit of a kludge, since it prevents use of the string
940# even in comments, but for now it does the job with no false positives.
941sc_prohibit_stat_st_blocks:
a927b6c1
LC
942 @prohibit='[.>]st_blocks' \
943 halt='do not use st_blocks; use ST_NBLOCKS' \
944 $(_sc_search_regexp)
c84bdaf6
LC
945
946# Make sure we don't define any S_IS* macros in src/*.c files.
947# They're already defined via gnulib's sys/stat.h replacement.
948sc_prohibit_S_IS_definition:
a927b6c1
LC
949 @prohibit='^ *# *define *S_IS' \
950 halt='do not define S_IS* macros; include <sys/stat.h>' \
951 $(_sc_search_regexp)
952
3d458a81
AW
953# Perl block to convert a match to FILE_NAME:LINENO:TEST,
954# that is shared by two definitions below.
955perl_filename_lineno_text_ = \
dd7d0148
LC
956 -e ' {' \
957 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
958 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
959 -e ' print "$$ARGV:$$n:$$v\n";' \
960 -e ' }'
961
3d458a81
AW
962prohibit_doubled_word_RE_ ?= \
963 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
964prohibit_doubled_word_ = \
965 -e 'while ($(prohibit_doubled_word_RE_))' \
966 $(perl_filename_lineno_text_)
967
dd7d0148
LC
968# Define this to a regular expression that matches
969# any filename:dd:match lines you want to ignore.
970# The default is to ignore no matches.
971ignore_doubled_word_match_RE_ ?= ^$$
972
973sc_prohibit_doubled_word:
974 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
975 | grep -vE '$(ignore_doubled_word_match_RE_)' \
976 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
977
3d458a81
AW
978# A regular expression matching undesirable combinations of words like
979# "can not"; this matches them even when the two words appear on different
980# lines, but not when there is an intervening delimiter like "#" or "*".
005de2e8
LC
981# Similarly undesirable, "See @xref{...}", since an @xref should start
982# a sentence. Explicitly prohibit any prefix of "see" or "also".
983# Also prohibit a prefix matching "\w+ +".
984# @pxref gets the same see/also treatment and should be parenthesized;
985# presume it must *not* start a sentence.
986bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
987bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
3d458a81 988prohibit_undesirable_word_seq_RE_ ?= \
005de2e8 989 /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
3d458a81
AW
990prohibit_undesirable_word_seq_ = \
991 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
992 $(perl_filename_lineno_text_)
993# Define this to a regular expression that matches
994# any filename:dd:match lines you want to ignore.
995# The default is to ignore no matches.
996ignore_undesirable_word_sequence_RE_ ?= ^$$
997
998sc_prohibit_undesirable_word_seq:
999 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
1000 $$($(VC_LIST_EXCEPT)) \
1001 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
1002 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
dd7d0148 1003
a927b6c1
LC
1004_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1005_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1006# Using test's -a and -o operators is not portable.
1007# We prefer test over [, since the latter is spelled [[ in configure.ac.
1008sc_prohibit_test_minus_ao:
1009 @prohibit='(\<test| \[+) .+ -[ao] ' \
1010 halt='$(_ptm1); $(_ptm2)' \
1011 $(_sc_search_regexp)
c84bdaf6 1012
0f00f2c3
LC
1013# Avoid a test bashism.
1014sc_prohibit_test_double_equal:
1015 @prohibit='(\<test| \[+) .+ == ' \
1016 containing='#! */bin/[a-z]*sh' \
1017 halt='use "test x = x", not "test x =''= x"' \
1018 $(_sc_search_regexp)
1019
61cd9dc9
LC
1020# Each program that uses proper_name_utf8 must link with one of the
1021# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
1022# The perl -0777 invocation below extracts the possibly-multi-line
1023# definition of LDADD from the appropriate Makefile.am and exits 0
1024# when it contains "ICONV".
c84bdaf6
LC
1025sc_proper_name_utf8_requires_ICONV:
1026 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
1027 if test "x$$progs" != x; then \
1028 fail=0; \
1029 for p in $$progs; do \
1030 dir=$$(dirname "$$p"); \
61cd9dc9
LC
1031 perl -0777 \
1032 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1033 $$dir/Makefile.am && continue; \
c84bdaf6
LC
1034 base=$$(basename "$$p" .c); \
1035 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1036 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1037 done; \
1038 test $$fail = 1 && \
1039 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1040 exit 1; } || :; \
1041 fi
1042
1043# Warn about "c0nst struct Foo const foo[]",
1044# but not about "char const *const foo" or "#define const const".
1045sc_redundant_const:
a927b6c1
LC
1046 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1047 halt='redundant "const" in declarations' \
1048 $(_sc_search_regexp)
c84bdaf6
LC
1049
1050sc_const_long_option:
005de2e8
LC
1051 @prohibit='^ *static.*struct option ' \
1052 exclude='const struct option|struct option const' \
7ae4e75a 1053 halt='add "const" to the above declarations' \
005de2e8 1054 $(_sc_search_regexp)
c84bdaf6
LC
1055
1056NEWS_hash = \
8f7887d6 1057 $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
c84bdaf6 1058 $(srcdir)/NEWS \
61cd9dc9
LC
1059 | perl -0777 -pe \
1060 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6 1061 | md5sum - \
8f7887d6 1062 | $(SED) 's/ .*//')
c84bdaf6
LC
1063
1064# Ensure that we don't accidentally insert an entry into an old NEWS block.
1065sc_immutable_NEWS:
1066 @if test -f $(srcdir)/NEWS; then \
1067 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1068 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1069 fi
1070
1071# Update the hash stored above. Do this after each release and
1072# for any corrections to old entries.
1073update-NEWS-hash: NEWS
1074 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1075 $(srcdir)/cfg.mk
1076
1077# Ensure that we use only the standard $(VAR) notation,
1078# not @...@ in Makefile.am, now that we can rely on automake
1079# to emit a definition for each substituted variable.
dd7d0148
LC
1080# However, there is still one case in which @VAR@ use is not just
1081# legitimate, but actually required: when augmenting an automake-defined
1082# variable with a prefix. For example, gettext uses this:
1083# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1084# otherwise, makeinfo would put German or French (current locale)
1085# navigation hints in the otherwise-English documentation.
1086#
61cd9dc9
LC
1087# Allow the package to add exceptions via a hook in cfg.mk;
1088# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1089# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1090_makefile_at_at_check_exceptions ?=
1091sc_makefile_at_at_check:
005de2e8
LC
1092 @perl -ne '/\@\w+\@/' \
1093 -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
dd7d0148 1094 -e ''$(_makefile_at_at_check_exceptions) \
c84bdaf6 1095 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
dd7d0148 1096 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
c84bdaf6
LC
1097 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1098
1cd4fffc 1099news-check: NEWS
8f7887d6 1100 $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $< \
9157d901 1101 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
1102 :; \
1103 else \
1cd4fffc 1104 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
1105 exit 1; \
1106 fi
1107
1108sc_makefile_TAB_only_indentation:
a927b6c1
LC
1109 @prohibit='^ [ ]{8}' \
1110 in_vc_files='akefile|\.mk$$' \
1111 halt='found TAB-8-space indentation' \
1112 $(_sc_search_regexp)
c84bdaf6
LC
1113
1114sc_m4_quote_check:
a927b6c1
LC
1115 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1116 in_vc_files='(^configure\.ac|\.m4)$$' \
1117 halt='quote the first arg to AC_DEF*' \
1118 $(_sc_search_regexp)
c84bdaf6
LC
1119
1120fix_po_file_diag = \
1121'you have changed the set of files with translatable diagnostics;\n\
1122apply the above patch\n'
1123
7ae4e75a
LC
1124# Verify that all source files using _() (more specifically, files that
1125# match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
dd7d0148 1126po_file ?= $(srcdir)/po/POTFILES.in
3d458a81 1127generated_files ?= $(srcdir)/lib/*.[ch]
7ae4e75a 1128_gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
c84bdaf6
LC
1129sc_po_check:
1130 @if test -f $(po_file); then \
1131 grep -E -v '^(#|$$)' $(po_file) \
1132 | grep -v '^src/false\.c$$' | sort > $@-1; \
1133 files=; \
3d458a81 1134 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
c84bdaf6
LC
1135 test -r $$file || continue; \
1136 case $$file in \
1137 *.m4|*.mk) continue ;; \
1138 *.?|*.??) ;; \
1139 *) continue;; \
1140 esac; \
1141 case $$file in \
1142 *.[ch]) \
1143 base=`expr " $$file" : ' \(.*\)\..'`; \
1144 { test -f $$base.l || test -f $$base.y; } && continue;; \
1145 esac; \
1146 files="$$files $$file"; \
1147 done; \
7ae4e75a 1148 grep -E -l '$(_gl_translatable_string_re)' $$files \
8f7887d6 1149 | $(SED) 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
c84bdaf6
LC
1150 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1151 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1152 rm -f $@-1 $@-2; \
1153 fi
1154
1155# Sometimes it is useful to change the PATH environment variable
1156# in Makefiles. When doing so, it's better not to use the Unix-centric
f0007cad 1157# path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
7ae4e75a 1158msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
c84bdaf6 1159sc_makefile_path_separator_check:
a927b6c1
LC
1160 @prohibit='PATH[=].*:' \
1161 in_vc_files='akefile|\.mk$$' \
1162 halt=$(msg) \
1163 $(_sc_search_regexp)
c84bdaf6 1164
f0007cad 1165# Check that 'make alpha' will not fail at the end of the process,
35428fb6
LC
1166# i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1167# and is read-only.
c84bdaf6 1168writable-files:
7ae4e75a 1169 $(AM_V_GEN)if test -d $(release_archive_dir); then \
35428fb6
LC
1170 for file in $(DIST_ARCHIVES); do \
1171 for p in ./ $(release_archive_dir)/; do \
1172 test -e $$p$$file || continue; \
1173 test -w $$p$$file \
1174 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1175 done; \
c84bdaf6
LC
1176 done; \
1177 test "$$fail" && exit 1 || : ; \
35428fb6 1178 else :; \
c84bdaf6
LC
1179 fi
1180
2e65b52f 1181v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
1182sample-test = tests/sample-test
1183texi = doc/$(PACKAGE).texi
1184# Make sure that the copyright date in $(v_etc_file) is up to date.
1185# Do the same for the $(sample-test) and the main doc/.texi file.
1186sc_copyright_check:
a927b6c1
LC
1187 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1188 in_files=$(v_etc_file) \
1189 halt='out of date copyright in $(v_etc_file); update it' \
1190 $(_sc_search_regexp)
1191 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1192 in_vc_files=$(sample-test) \
1193 halt='out of date copyright in $(sample-test); update it' \
1194 $(_sc_search_regexp)
1195 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1196 in_vc_files=$(texi) \
1197 halt='out of date copyright in $(texi); update it' \
1198 $(_sc_search_regexp)
1199
1200# If tests/help-version exists and seems to be new enough, assume that its
1201# use of init.sh and path_prepend_ is correct, and ensure that every other
1202# use of init.sh is identical.
1203# This is useful because help-version cross-checks prog --version
1204# with $(VERSION), which verifies that its path_prepend_ invocation
1205# sets PATH correctly. This is an inexpensive way to ensure that
1206# the other init.sh-using tests also get it right.
1207_hv_file ?= $(srcdir)/tests/help-version
1208_hv_regex_weak ?= ^ *\. .*/init\.sh"
231c0e0e 1209# Fix syntax-highlighters "
a927b6c1
LC
1210_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1211sc_cross_check_PATH_usage_in_tests:
1212 @if test -f $(_hv_file); then \
1213 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1214 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1215 exit 0; }; \
1216 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1217 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1218 exit 1; }; \
1219 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1220 grep -LFx "$$good" \
1221 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1222 | grep . && \
1223 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1224 1>&2; exit 1; } || :; \
c84bdaf6
LC
1225 fi
1226
7f1ea859
LC
1227# BRE regex of file contents to identify a test script.
1228_test_script_regex ?= \<init\.sh\>
1229
1230# In tests, use "compare expected actual", not the reverse.
1231sc_prohibit_reversed_compare_failure:
1232 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1233 containing='$(_test_script_regex)' \
1234 halt='reversed compare arguments' \
1235 $(_sc_search_regexp)
1236
61cd9dc9
LC
1237# #if HAVE_... will evaluate to false for any non numeric string.
1238# That would be flagged by using -Wundef, however gnulib currently
1239# tests many undefined macros, and so we can't enable that option.
1240# So at least preclude common boolean strings as macro values.
1241sc_Wundef_boolean:
a927b6c1
LC
1242 @prohibit='^#define.*(yes|no|true|false)$$' \
1243 in_files='$(CONFIG_INCLUDE)' \
1244 halt='Use 0 or 1 for macro values' \
1245 $(_sc_search_regexp)
61cd9dc9 1246
231c0e0e
LC
1247# Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1248# not be constant, or might overflow a stack. In general, use PATH_MAX as
1249# a limit, not an array or alloca size.
1250sc_prohibit_path_max_allocation:
7ae4e75a 1251 @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
231c0e0e
LC
1252 halt='Avoid stack allocations of size PATH_MAX' \
1253 $(_sc_search_regexp)
1254
61cd9dc9 1255sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1 1256 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
7ae4e75a 1257 in_files='(^|/)Makefile\.in$$' \
0f00f2c3
LC
1258 halt=$$(printf '%s\n' \
1259 'the above files are vulnerable; beware of running' \
1260 ' "make dist*" rules, and upgrade to fixed automake' \
1261 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1262 $(_sc_search_regexp)
61cd9dc9 1263
7ae4e75a
LC
1264sc_vulnerable_makefile_CVE-2012-3386:
1265 @prohibit='chmod a\+w \$$\(distdir\)' \
1266 in_files='(^|/)Makefile\.in$$' \
1267 halt=$$(printf '%s\n' \
1268 'the above files are vulnerable; beware of running' \
1269 ' "make distcheck", and upgrade to fixed automake' \
1270 ' see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1271 $(_sc_search_regexp)
1272
c84bdaf6 1273vc-diff-check:
7ae4e75a
LC
1274 $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1275 $(AM_V_at)if test -s vc-diffs; then \
c84bdaf6
LC
1276 cat vc-diffs; \
1277 echo "Some files are locally modified:" 1>&2; \
1278 exit 1; \
1279 else \
1280 rm vc-diffs; \
1281 fi
1282
c84bdaf6
LC
1283rel-files = $(DIST_ARCHIVES)
1284
1285gnulib_dir ?= $(srcdir)/gnulib
5e69ceb7
MW
1286gnulib-version = $$(cd $(gnulib_dir) \
1287 && { git describe || git rev-parse --short=10 HEAD; } )
c84bdaf6
LC
1288bootstrap-tools ?= autoconf,automake,gnulib
1289
5e69ceb7 1290gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
61cd9dc9
LC
1291# If it's not already specified, derive the GPG key ID from
1292# the signed tag we've just applied to mark this release.
7ae4e75a
LC
1293gpg_key_ID ?= \
1294 $$(cd $(srcdir) \
1295 && git cat-file tag v$(VERSION) \
5e69ceb7 1296 | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null \
7ae4e75a 1297 | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
61cd9dc9 1298
a927b6c1 1299translation_project_ ?= coordinator@translationproject.org
3d458a81
AW
1300
1301# Make info-gnu the default only for a stable release.
7ae4e75a
LC
1302announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
1303announcement_mail_headers_stable = \
1304 To: info-gnu@gnu.org \
1305 Cc: $(announcement_Cc_) \
1306 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1307
1308announcement_Cc_alpha = $(translation_project_)
1309announcement_mail_headers_alpha = \
1310 To: $(PACKAGE_BUGREPORT) \
1311 Cc: $(announcement_Cc_)
1312
1313announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
1314announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
1315
1316announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
1317announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
c84bdaf6 1318announcement: NEWS ChangeLog $(rel-files)
7ae4e75a 1319# Not $(AM_V_GEN) since the output of this command serves as
af07e104 1320# announcement message: it would start with " GEN announcement".
7ae4e75a 1321 $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
a927b6c1 1322 --mail-headers='$(announcement_mail_headers_)' \
7ae4e75a 1323 --release-type=$(release-type) \
c84bdaf6
LC
1324 --package=$(PACKAGE) \
1325 --prev=$(PREV_VERSION) \
1326 --curr=$(VERSION) \
1327 --gpg-key-id=$(gpg_key_ID) \
005de2e8 1328 --srcdir=$(srcdir) \
61cd9dc9 1329 --news=$(srcdir)/NEWS \
c84bdaf6 1330 --bootstrap-tools=$(bootstrap-tools) \
005de2e8
LC
1331 $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
1332 echo --gnulib-version=$(gnulib-version);; esac) \
c84bdaf6
LC
1333 --no-print-checksums \
1334 $(addprefix --url-dir=, $(url_dir_list))
1335
7ae4e75a
LC
1336.PHONY: release-commit
1337release-commit:
1338 $(AM_V_GEN)cd $(srcdir) \
1339 && $(_build-aux)/do-release-commit-and-tag \
1340 -C $(abs_builddir) $(RELEASE)
1341
c84bdaf6
LC
1342## ---------------- ##
1343## Updating files. ##
1344## ---------------- ##
1345
1346ftp-gnu = ftp://ftp.gnu.org/gnu
1347www-gnu = http://www.gnu.org
1348
dde9c5a4 1349upload_dest_dir_ ?= $(PACKAGE)
7ae4e75a
LC
1350upload_command = \
1351 $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
1352 --to $(gnu_rel_host):$(upload_dest_dir_) \
1353 $(rel-files)
c84bdaf6
LC
1354emit_upload_commands:
1355 @echo =====================================
1356 @echo =====================================
7ae4e75a 1357 @echo '$(upload_command)'
61cd9dc9 1358 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1359 @echo =====================================
1360 @echo =====================================
1361
7ae4e75a
LC
1362.PHONY: upload
1363upload:
1364 $(AM_V_GEN)$(upload_command)
1365
c84bdaf6 1366define emit-commit-log
35428fb6
LC
1367 printf '%s\n' 'maint: post-release administrivia' '' \
1368 '* NEWS: Add header line for next release.' \
1369 '* .prev-version: Record previous version.' \
c84bdaf6
LC
1370 '* cfg.mk (old_NEWS_hash): Auto-update.'
1371endef
1372
1373.PHONY: no-submodule-changes
1374no-submodule-changes:
af07e104
AW
1375 $(AM_V_GEN)if test -d $(srcdir)/.git \
1376 && git --version >/dev/null 2>&1; then \
c84bdaf6
LC
1377 diff=$$(cd $(srcdir) && git submodule -q foreach \
1378 git diff-index --name-only HEAD) \
1379 || exit 1; \
1380 case $$diff in '') ;; \
1381 *) echo '$(ME): submodule files are locally modified:'; \
1382 echo "$$diff"; exit 1;; esac; \
1383 else \
1384 : ; \
1385 fi
1386
49114fd4
LC
1387submodule-checks ?= no-submodule-changes public-submodule-commit
1388
1389# Ensure that each sub-module commit we're using is public.
1390# Without this, it is too easy to tag and release code that
1391# cannot be built from a fresh clone.
1392.PHONY: public-submodule-commit
1393public-submodule-commit:
af07e104
AW
1394 $(AM_V_GEN)if test -d $(srcdir)/.git \
1395 && git --version >/dev/null 2>&1; then \
49114fd4 1396 cd $(srcdir) && \
af07e104 1397 git submodule --quiet foreach \
5e69ceb7
MW
1398 'test "$$(git rev-parse "$$sha1")" \
1399 = "$$(git merge-base origin "$$sha1")"' \
49114fd4
LC
1400 || { echo '$(ME): found non-public submodule commit' >&2; \
1401 exit 1; }; \
1402 else \
1403 : ; \
1404 fi
1405# This rule has a high enough utility/cost ratio that it should be a
1406# dependent of "check" by default. However, some of us do occasionally
1407# commit a temporary change that deliberately points to a non-public
1408# submodule commit, and want to be able to use rules like "make check".
1409# In that case, run e.g., "make check gl_public_submodule_commit="
1410# to disable this test.
1411gl_public_submodule_commit ?= public-submodule-commit
1412check: $(gl_public_submodule_commit)
1413
7ae4e75a 1414.PHONY: alpha beta stable release
c84bdaf6 1415ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1416alpha beta stable: $(local-check) writable-files $(submodule-checks)
7ae4e75a 1417 $(AM_V_GEN)test $@ = stable \
c84bdaf6
LC
1418 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1419 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1420 || :
7ae4e75a
LC
1421 $(AM_V_at)$(MAKE) vc-diff-check
1422 $(AM_V_at)$(MAKE) news-check
1423 $(AM_V_at)$(MAKE) distcheck
1424 $(AM_V_at)$(MAKE) dist
1425 $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1426 $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1427
1428release:
5e69ceb7 1429 $(AM_V_GEN)$(MAKE) _version
7ae4e75a 1430 $(AM_V_GEN)$(MAKE) $(release-type)
1cd4fffc
LC
1431
1432# Override this in cfg.mk if you follow different procedures.
1433release-prep-hook ?= release-prep
1434
0f00f2c3 1435gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1436.PHONY: release-prep
1437release-prep:
7ae4e75a
LC
1438 $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1439 > ~/announce-$(my_distdir)
1440 $(AM_V_at)if test -d $(release_archive_dir); then \
c84bdaf6
LC
1441 ln $(rel-files) $(release_archive_dir); \
1442 chmod a-w $(rel-files); \
1443 fi
7ae4e75a
LC
1444 $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1445 $(AM_V_at)$(MAKE) update-NEWS-hash
1446 $(AM_V_at)perl -pi \
1447 -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
1448 $(srcdir)/NEWS
1449 $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
1450 cd $(srcdir) && $(VC) commit -m "$$msg" -a
c84bdaf6 1451
a927b6c1
LC
1452# Override this with e.g., -s $(srcdir)/some_other_name.texi
1453# if the default $(PACKAGE)-derived name doesn't apply.
1454gendocs_options_ ?=
1455
c84bdaf6
LC
1456.PHONY: web-manual
1457web-manual:
7ae4e75a 1458 $(AM_V_GEN)test -z "$(manual_title)" \
c84bdaf6 1459 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
7ae4e75a 1460 $(AM_V_at)cd '$(srcdir)/doc'; \
7f1ea859 1461 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
a927b6c1 1462 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1463 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1464 "$(PACKAGE_NAME) - $(manual_title)"
7ae4e75a
LC
1465 $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1466
1467.PHONY: web-manual-update
1468web-manual-update:
1469 $(AM_V_GEN)cd $(srcdir) \
1470 && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1471
c84bdaf6
LC
1472
1473# Code Coverage
1474
1475init-coverage:
1476 $(MAKE) $(AM_MAKEFLAGS) clean
1477 lcov --directory . --zerocounters
1478
1479COVERAGE_CCOPTS ?= "-g --coverage"
1480COVERAGE_OUT ?= doc/coverage
1481
1482build-coverage:
1483 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1484 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1485 mkdir -p $(COVERAGE_OUT)
1486 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1487 --capture
1488
1489gen-coverage:
1490 genhtml --output-directory $(COVERAGE_OUT) \
1491 $(COVERAGE_OUT)/$(PACKAGE).info \
1492 --highlight --frames --legend \
1493 --title "$(PACKAGE_NAME)"
1494
1495coverage: init-coverage build-coverage gen-coverage
1496
7ae4e75a
LC
1497# Some projects carry local adjustments for gnulib modules via patches in
1498# a gnulib patch directory whose default name is gl/ (defined in bootstrap
1499# via local_gl_dir=gl). Those patches become stale as the originals evolve
1500# in gnulib. Use this rule to refresh any stale patches. It applies each
1501# patch to the original in $(gnulib_dir) and uses the temporary result to
1502# generate a fuzz-free .diff file. If you customize the name of your local
1503# gnulib patch directory via bootstrap.conf, this rule detects that name.
1504# Run this from a non-VPATH (i.e., srcdir) build directory.
1505.PHONY: refresh-gnulib-patches
1506refresh-gnulib-patches:
1507 gl=gl; \
1508 if test -f bootstrap.conf; then \
1509 t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
1510 -e 'END{defined $$d and print $$d}' bootstrap.conf); \
1511 test -n "$$t" && gl=$$t; \
1512 fi; \
1513 for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do \
8f7887d6 1514 b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//'); \
7ae4e75a
LC
1515 VERSION_CONTROL=none \
1516 patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
1517 ( cd $(gnulib_dir) || exit 1; \
1518 git diff "$$b" > "../$$gl/$$diff"; \
1519 git checkout $$b ) || exit 1; \
1520 done
1521
c84bdaf6
LC
1522# Update gettext files.
1523PACKAGE ?= $(shell basename $(PWD))
1524PO_DOMAIN ?= $(PACKAGE)
1525POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1526PODIR ?= po
1527refresh-po:
1528 rm -f $(PODIR)/*.po && \
1529 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1530 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1531 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1532 echo 'en@quot' >> $(PODIR)/LINGUAS && \
8f7887d6
LC
1533 ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
1534 sort >> $(PODIR)/LINGUAS
c84bdaf6 1535
a927b6c1 1536 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1537INDENT_SOURCES ?= $(C_SOURCES)
1538.PHONY: indent
1539indent:
1540 indent $(INDENT_SOURCES)
a927b6c1 1541 indent $(INDENT_SOURCES)
c84bdaf6
LC
1542
1543# If you want to set UPDATE_COPYRIGHT_* environment variables,
1544# put the assignments in this variable.
1545update-copyright-env ?=
1546
1547# Run this rule once per year (usually early in January)
1548# to update all FSF copyright year lists in your project.
1549# If you have an additional project-specific rule,
1550# add it in cfg.mk along with a line 'update-copyright: prereq'.
1551# By default, exclude all variants of COPYING; you can also
1552# add exemptions (such as ChangeLog..* for rotated change logs)
1553# in the file .x-update-copyright.
1554.PHONY: update-copyright
1555update-copyright:
7ae4e75a 1556 $(AM_V_GEN)grep -l -w Copyright \
c84bdaf6 1557 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
7f1ea859 1558 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
3d458a81
AW
1559
1560# This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1561# overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1562
1563# NOTE: to override any _gl_TS_* default value, you must
1564# define the variable(s) using "export" in cfg.mk.
1565_gl_TS_dir ?= src
1566
1567ALL_RECURSIVE_TARGETS += sc_tight_scope
1568sc_tight_scope: tight-scope.mk
35428fb6
LC
1569 @fail=0; \
1570 if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
3d458a81
AW
1571 > /dev/null \
1572 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1573 > /dev/null 2>&1; then \
1574 echo '$(ME): skipping $@'; \
1575 else \
1576 $(MAKE) -s -C $(_gl_TS_dir) \
1577 -f Makefile \
1578 -f $(abs_top_srcdir)/cfg.mk \
1579 -f $(abs_top_builddir)/$< \
1580 _gl_tight_scope \
1581 || fail=1; \
35428fb6
LC
1582 fi; \
1583 rm -f $<; \
1584 exit $$fail
3d458a81
AW
1585
1586tight-scope.mk: $(ME)
1587 @rm -f $@ $@-t
7f1ea859 1588 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
3d458a81
AW
1589 @chmod a=r $@-t && mv $@-t $@
1590
1591ifeq (a,b)
1592# TS-start
1593
1594# Most functions should have static scope.
f0007cad
LC
1595# Any that don't must be marked with 'extern', but 'main'
1596# and 'usage' are exceptions: they're always extern, but
1597# do not need to be marked. Symbols matching '__.*' are
3d458a81
AW
1598# reserved by the compiler, so are automatically excluded below.
1599_gl_TS_unmarked_extern_functions ?= main usage
35428fb6 1600_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
3d458a81
AW
1601
1602# If your project uses a macro like "XTERN", then put
1603# the following in cfg.mk to override this default:
1604# export _gl_TS_extern = extern|XTERN
1605_gl_TS_extern ?= extern
1606
f0007cad 1607# The second nm|grep checks for file-scope variables with 'extern' scope.
3d458a81 1608# Without gnulib's progname module, you might put program_name here.
f0007cad 1609# Symbols matching '__.*' are reserved by the compiler,
3d458a81
AW
1610# so are automatically excluded below.
1611_gl_TS_unmarked_extern_vars ?=
1612
1613# NOTE: the _match variables are perl expressions -- not mere regular
1614# expressions -- so that you can extend them to match other patterns
1615# and easily extract matched variable names.
1616# For example, if your project declares some global variables via
1617# a macro like this: GLOBAL(type, var_name, initializer), then you
1618# can override this definition to automatically extract those names:
1619# export _gl_TS_var_match = \
1620# /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1621_gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1622
1623# The names of object files in (or relative to) $(_gl_TS_dir).
1624_gl_TS_obj_files ?= *.$(OBJEXT)
1625
1626# Files in which to search for the one-line style extern declarations.
1627# $(_gl_TS_dir)-relative.
1628_gl_TS_headers ?= $(noinst_HEADERS)
7ae4e75a 1629_gl_TS_other_headers ?= *.h
3d458a81
AW
1630
1631.PHONY: _gl_tight_scope
1632_gl_tight_scope: $(bin_PROGRAMS)
1633 t=exceptions-$$$$; \
1634 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1635 for sig in 1 2 3 13 15; do \
1636 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1637 done; \
1638 src=`for f in $(SOURCES); do \
1639 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1640 hdr=`for f in $(_gl_TS_headers); do \
1641 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1642 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1643 grep -h -A1 '^extern .*[^;]$$' $$src \
8f7887d6 1644 | grep -vE '^(extern |--)' | $(SED) 's/ .*//'; \
3d458a81
AW
1645 perl -lne \
1646 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1647 ) | sort -u > $$t; \
8f7887d6 1648 nm -e $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|grep -Ev -f $$t \
3d458a81
AW
1649 && { echo the above functions should have static scope >&2; \
1650 exit 1; } || : ; \
1651 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
7ae4e75a
LC
1652 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' \
1653 $$hdr $(_gl_TS_other_headers) \
3d458a81 1654 ) | sort -u > $$t; \
8f7887d6 1655 nm -e $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p' \
3d458a81
AW
1656 | sort -u | grep -Ev -f $$t \
1657 && { echo the above variables should have static scope >&2; \
1658 exit 1; } || :
1659# TS-end
1660endif